



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[译文]Domain Driven Design Reference（六）—— 提炼战略设计</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[译文]Domain Driven Design Reference（六）—— 提炼战略设计</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 03:40:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>本书是Eric Evans对他自己写的《领域驱动设计-软件核心复杂性应对之道》的一本字典式的参考书，可用于快速查找《领域驱动设计》中的诸多概念及其简明解释。</p></blockquote>
<p>其它本系列其它文章地址：</p>
<p><a href="http://www.cnblogs.com/Zachary-Fan/p/DDDReference1.html" rel="external nofollow noreferrer">[译文]Domain Driven Design Reference（一）&mdash;&mdash; 前言</a></p>
<p><a href="http://www.cnblogs.com/Zachary-Fan/p/DDDReference2.html" rel="external nofollow noreferrer">[译文]Domain Driven Design Reference（二）&mdash;&mdash; 让模型起作用</a></p>
<p><a href="http://www.cnblogs.com/Zachary-Fan/p/DDDReference3.html" rel="external nofollow noreferrer">[译文]Domain Driven Design Reference（三）&mdash;&mdash; 模型驱动设计的构建模块</a></p>
<p><a href="https://www.cnblogs.com/Zachary-Fan/p/DDDReference4.html" rel="external nofollow noreferrer">[译文]Domain Driven Design Reference（四）&mdash;&mdash;&nbsp;柔性设计</a></p>
<p><a href="https://www.cnblogs.com/Zachary-Fan/p/DDDReference5.html" rel="external nofollow noreferrer">[译文]Domain Driven Design Reference（五）&mdash;&mdash;&nbsp;为战略设计的上下文映射</a></p>
<p><a href="https://www.cnblogs.com/Zachary-Fan/p/DDDReference6.html" rel="external nofollow noreferrer">[译文]Domain Driven Design Reference（六）&mdash;&mdash;&nbsp;提炼战略设计</a></p>
<p>　　你如何专注于你的核心问题，并避免陷入一大堆细枝末节？</p>
<p>　　提炼是是一种分离混合物成分的过程，以提取出一种使其更有价值和有用的形式。模型是知识的提炼。随着每一次重构的深入，我们抽象出领域知识和优先级的一些关键方面。现在，回过头来看战略视角，本章将探讨如何区分模型的涉猎范围并提炼整个领域模型。</p>
<h2>核心领域</h2>
<p>　　在一个大型系统中，有太多的合作组件，一切都很复杂，但都是成功的必要条件，所以领域模型的本质，真正的商业资产，可能会被掩盖和忽略。</p>
<p>　　残酷的现实是，并非所有设计的部分都要同样的精炼。优先事项必须确定。为了使领域模型成为一种资产，该模型的关键核心必须是整洁且充分利用来创建应用程序功能。但是缺乏丰富经验的开发者倾向于对技术基础设施或者可清晰定义的领域问题感兴趣，这些问题可以在没有专门领域知识的情况下被理解。</p>
<p>　　因此：</p>
<p><strong>　　归纳模型。定义一个核心域，并提供一种可以很容易区分支持模型和代码的方法。让最有价值和最专业的概念显露出来。</strong></p>
<p><strong>　　将顶尖人才应用到核心领域，并据此招聘。在核心中花费精力寻找一个深层的模型，并开发一个柔性设计来实现系统的远景。</strong></p>
<p>　　通过如何支持提炼出来的核心来证明对其他任何部分的投资是合理的。</p>
<h2>通用子域</h2>
<p>　　模型的某些部分增加了复杂性，而没有捕获或传播专业知识。任何无关紧要的东西都会使核心领域更难识别和理解。这个模型符合所有人都知道或者是属于专业的一般原则，这些原则不是你的主要关注点，而是发挥辅助作用。然而，这些其他的元素对于系统的功能和模型的完整表达都是必不可少的。</p>
<p>　　因此：</p>
<p>　　<strong>识别不是你的项目动机的内聚子域。提取出这些子域的通用模型，并将它们放在单独的模块中。不要留下你的特点。</strong></p>
<p><strong>　　一旦它们被分离，将它们的后续开发优先级置于核心领域之下，并避免你的核心去做这些任务（因为这些核心开发将从他们那里获得很少的领域知识）。还要考虑这些通用子域的现成解决方案或已发布的模型</strong>。</p>
<h2>领域愿景宣言</h2>
<p>　　在项目开始时，模型通常是不存在的，但是关注其发展的需求已经存在。在开发的后期阶段，需要对系统的价值进行解释，而不需要对模型进行深入研究。此外，领域模型的关键方面可能跨越多个限界上下文，但是根据定义，这些不同的模型不能被构造来显示它们的共同焦点。</p>
<p>　　因此：</p>
<p>　　<strong>写一个关于核心领域的简短描述（大概一页）以及它将带来的价值，即&ldquo;价值主张&rdquo;。忽略那些不区分该领域模型和其它东西的方面。显示领域模型如何服务和平衡多种利益。保持它的精简。尽早写下此声明，并在获得新见解时对其进行修改。</strong></p>
<h2>突出核心</h2>
<p>　　<em>领域愿景宣言以广义的术语来标识核心领域，但是它将特定的核心模型元素的识别留给了个体的解释。除非团队中的沟通水平非常高，否则单凭愿景宣言没有多大影响。</em></p>
<p>　　即使团队成员大致知道什么是核心领域，但不同的人不会挑出相同的元素，即使是同一个人，在不同的时间点做出的选择也不一定是一致的。不断过滤模型以识别关键部分的脑力劳动更好地将注意力集中在设计思维上，并且需要对模型有全面的认识。必须使核心域更容易看到。</p>
<p>　　对代码进行重大的重构是识别核心领域的理想方式，但它们在短期内并不总是实用的。事实上，如果没有团队所缺乏的观点，这种重大的代码重构就很难进行。</p>
<p>　　因此（作为突出核心的一种形式）：</p>
<p>　　<strong>编写一个非常简短的文档(3到7个简单页面)，描述核心领域和核心元素之间的主要交互。</strong></p>
<p>　　和/或（作为突出核心的另一种形式）：</p>
<p>　　<strong>在模型的主存储库中标记核心领域的元素，而不是特别地试图阐明其角色。让开发人员轻松了解核心的内外内容。</strong></p>
<p>　　如果浓缩文件概括了核心领域的要点，那么它就可以作为一个实际的指标，说明模型变更的重要性。当模型或代码变更影响到浓缩文档时，需要与其他团队成员协商。当更改完成时，需要立即通知所有团队成员，并传播新版本的文档。除核心外的变更或未包含在浓缩文档中的细节，可以不经协商或通知的情况下进行而集成，并且其他成员在其工作过程中也会遇到。然后开发人员拥有绝大多数敏捷过程所建议的自主权。</p>
<p>　　<em>尽管有愿景宣言和突出的核心信息和指南的存在，但是它们实际上并没有修改模型或代码本身。划分通用子域将从物理上去除一些分散注意力的元素。接下来，我们将研究其它方式来结构性地更改模型和设计本身，以使核心领域更易理解和管理。。。</em></p>
<h2>内聚机制</h2>
<p>　　开始膨胀设计使得计算有时会达到一个复杂程序。概念性的"做什么"被机械的"如何做"所淹没。提供解决问题算法的大量方法模糊了表达问题的方法。</p>
<p>　　因此：</p>
<p>　　<strong>将概念上的内聚机制分离到一个单独的轻量级框架。特别注意形式主义或有良好文档的算法类别。用意图揭示接口来公开框架的功能。现在，领域中的其他元素就可以只专注与如何表达问题（做什么）了，而把解决方案的复杂细节（如何做）转移给了框架。</strong></p>
<p><strong>　　分解通用子域会减少混乱，而内聚机制有助于封装复杂的操作。这就留下了一个更专注的模型，减少了对用户进行活动的方式没有特别价值的这类干扰。但是，你不可能在没有核心的领域模型中找到好的结果。分离的核心是采取直接的方式来结构化地标记出核心领域。。。</strong></p>
<h2>隔离核心</h2>
<p>　　模型中的元素可能部分服务于核心领域，并且部分扮演辅助角色。核心元素可能与通用元素紧密耦合。核心的概念性内聚力可能不强或缺失。所有这些混乱和复杂关系扼杀了核心。设计师不能清楚地看到最重要的关系，导致设计薄弱。</p>
<p>　　因此：</p>
<p>　　<strong>对模型进行重构，把核心概念从支持性元素（包括定义得不清楚的那些元素）中分离出来，并增强核心的内聚性，同时减少它与其他代码的耦合。把所有通用元素或支持性元素提取到其他对象中，并把这些对象放到其他的包中，即使这会把一些紧密耦合的元素分开。</strong></p>
<h2>抽象核心</h2>
<p>　　即使是核心领域模型通常也有很多细节，因此沟通大局面可能是困难的。当单独模块中的子域之间存在很多交互时，要么在模块之间创建许多引用，要么就会破坏分区的大部分价值，否则交互将不得不间接地进行，这使得模型变得模糊。</p>
<p>　　因此：</p>
<p>　　<strong>确定模型中最基本的区分概念，并将它们分为不同的类，抽象类或接口。设计这个抽象模型，以表达大部分重要组件之间的交互。将这个抽象的整体模型放在它自己的模块中，而专门的、具体的实现类留在由子域定义的它们自己的模块中。</strong></p>
<p>作者：<a href="https://www.cnblogs.com/Zachary-Fan" rel="external nofollow noreferrer">Zachary_Fan</a><br />出处：<a href="http://www.cnblogs.com/Zachary-Fan/p/DDDReference6.html" rel="external nofollow noreferrer">http://www.cnblogs.com/Zachary-Fan/p/DDDReference6.html</a></p>
<blockquote><p>▶关于作者：张帆（Zachary，个人微信号：Zachary-ZF）。坚持用心打磨每一篇高质量原创。欢迎<strong>扫描右侧</strong>的二维码~。</p>
<p><strong>定期发表原创内容：架构设计丨分布式系统丨产品丨运营丨一些思考。</strong></p>
<p>如果你是初级程序员，想提升但不知道如何下手。又或者做程序员多年，陷入了一些瓶颈想拓宽一下视野。欢迎关注我的公众号「<strong><a href="https://mp.weixin.qq.com/s/My5Yf2pBdMNWwT_yywhofA" rel="external nofollow noreferrer">跨界架构师</a></strong>」，回复「<strong>技术</strong>」，送你一份我长期收集和整理的思维导图。</p>
<p>如果你是运营，面对不断变化的市场束手无策。又或者想了解主流的运营策略，以丰富自己的&ldquo;仓库&rdquo;。欢迎关注我的公众号「<strong><a href="https://mp.weixin.qq.com/s/My5Yf2pBdMNWwT_yywhofA" rel="external nofollow noreferrer">跨界架构师</a></strong>」，回复「<strong>运营</strong>」，送你一份我长期收集和整理的思维导图。</p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m2zerq.html">ABZ理论</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlvgjx9.html">VS2015 &plus;EF6 连接MYSQL数据库生成实体</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq46j438.html">接口测试中三种传参请求（Map、request、Integer）解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ow4pl9.html">关于360的META设置，强制使用极速模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnkoljq.html">java 基础第一季</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjzo09.html">Spring中属性文件properties的读取与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdg1pe8.html">ERP员工入职登记（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydyedgq.html">Flex 三态复选框</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1x1ev9.html">Unity3D连接真机调试教程，可抓断点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1yl2mq.html">在winform中怎样实现好看的treeview样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojl271q.html">JAVAscript学习笔记 js事件 第一节 （原创） 参考js使用表</a>
		</li>
						<li><a href="https://www.batexi.com/a/95074zz8.html">memcached内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj21ek9.html">python2 &equals;&amp;gt&semi; python3 踩坑集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gewye48.html">Shell中echo改变输出显示样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4o34j9.html">requests 的基本用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd02309.html">JavaScript -- Document-ElementsByName</a>
		</li>
						<li><a href="https://www.batexi.com/a/963mme39.html">solr java demo 基础入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4e7j1q.html">md5&comma;md2加密加盐</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pmj60q.html">lr计算程序执行消耗时间的比较：</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15ykd59.html">wifi 定位</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwj3l3z8.html">搭建Linux运行环境-虚拟机</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jp0xl8.html">ConditionalOnBean 与 ConditionalOnMissingBean 的正确玩法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjp5638.html">CollectionUtils工具类的常用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pvy448.html">提取Jar2Exe源代码，JavaAgent监控法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo031nq.html">Win10 iot 配置防火墙限制应用部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyz3vx9.html">mac抓包工具anyproxy</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv14341q.html">浅谈Java语言中try&lbrace;&rcub;catch&lbrace;&rcub;和finally&lbrace;&rcub;的执行顺序问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zlwxe9.html">Mac安装sqlite3</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj62nk9.html">1&period;3 正则表达式和python语言-1&period;3&period;6匹配多个字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geo0n48.html">我的 FPGA 学习历程（01）&mdash;&mdash; FPGA 基础知识和 Quartus 的安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
